<?php
defined('BASEPATH') or exit('No direct script access allowed');

require APPPATH . '/libraries/REST_Controller.php';
require APPPATH . '/libraries/Format.php';

use Restserver\Libraries\REST_Controller;

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST");

class Api_shopeepay_activity_cek extends REST_Controller
{

	public function __construct()
	{
		parent::__construct();
		$this->load->helper(['jwt', 'authorization']);
	}


	public function index_post()
	{
		date_default_timezone_set("Asia/Jakarta");
		//USER
		$mst_user_kode = $this->mst_user_kode();

		//SHOPEEPAY
		$trx_shopeepay_kode = $this->trx_shopeepay_kode();

		//PANGGIL SHOPEEPAY
		$shopeepay = $this->db->query("SELECT * FROM tbl_trx_shopeepay 
									WHERE 
									trx_shopeepay_kode='$trx_shopeepay_kode' and 
									trx_shopeepay_user_kode='$mst_user_kode'");
		if ($shopeepay->num_rows() > 0) {
			foreach ($shopeepay->result() as $row) {
				$data['transaksi'][] = array(
					'trx_shopeepay_kode' => encrypt($row->trx_shopeepay_kode, $this->config->item('key')),
					'trx_shopeepay_user_kode' => encrypt($row->trx_shopeepay_user_kode, $this->config->item('key')),
					'trx_shopeepay_nomor' => encrypt($row->trx_shopeepay_nomor, $this->config->item('key')),
					'trx_shopeepay_nama' => encrypt($row->trx_shopeepay_nama, $this->config->item('key')),
					'trx_shopeepay_admin' => encrypt(number_format($row->trx_shopeepay_admin, 0, ',', '.'), $this->config->item('key')),
					'trx_shopeepay_harga' => encrypt(number_format($row->trx_shopeepay_harga, 0, ',', '.'), $this->config->item('key')),
					'trx_shopeepay_total' => encrypt(number_format($row->trx_shopeepay_admin + $row->trx_shopeepay_harga, 0, ',', '.'), $this->config->item('key')),
					'trx_shopeepay_poin' => encrypt($row->trx_shopeepay_poin, $this->config->item('key')),
					'trx_shopeepay_sn' => encrypt($row->trx_shopeepay_sn, $this->config->item('key')),
					'trx_shopeepay_keterangan' => encrypt($row->trx_shopeepay_keterangan, $this->config->item('key')),
					'trx_shopeepay_notasi' => encrypt($row->trx_shopeepay_notasi, $this->config->item('key')),
					'trx_shopeepay_tanggal' => encrypt(date("d M Y H:i", strtotime($row->trx_shopeepay_tanggal)), $this->config->item('key')),
					'trx_shopeepay_icon' => encrypt($row->trx_shopeepay_icon, $this->config->item('key')),
					'trx_shopeepay_rc' => encrypt($row->trx_shopeepay_rc, $this->config->item('key')),
					'trx_shopeepay_status' => encrypt($row->trx_shopeepay_status, $this->config->item('key')),
				);
			}

			$sess["status"] = "001";
			$sess["pesan"] = "Berhasil";
			$keytoken = strtoupper(substr(sha1(uniqid()), 0, 16));;
			$sess['data'] = array(
				'token' =>  encrypt($keytoken, $this->config->item('keytoken')),
				'value' =>  encrypt(json_encode($data), $keytoken)
			);
			echo json_encode($sess);
		} else {
			$sess["status"] = "002";
			$sess["pesan"] = "Gagal mengambil data, silahkan refresh halaman secara berkala";
			$keytoken = strtoupper(substr(sha1(uniqid()), 0, 16));;
			$sess['data'] = array(
				'token' =>  encrypt($keytoken, $this->config->item('keytoken')),
				'value' =>  encrypt(json_encode(array()), $keytoken)
			);
			echo json_encode($sess);
		}
	}


	private function mst_user_kode()
	{
		$input = decrypt($this->input->post("mst_user_kode", true), $this->config->item('key'));
		$token = AUTHORIZATION::generateToken($input);
		try {
			$data = AUTHORIZATION::validateToken($token);
			if ($data === false) {
				$sess["status"] = "004";
				$sess["pesan"] = $this->config->item('error_parameter');
				$keytoken = strtoupper(substr(sha1(uniqid()), 0, 16));;
				$sess['data'] = array(
					'token' =>  encrypt($keytoken, $this->config->item('keytoken')),
					'value' =>  encrypt(json_encode(array()), $keytoken)
				);
				echo json_encode($sess);
				exit();
			} else {
				return $data;
			}
		} catch (Exception $e) {
			$sess["status"] = "004";
			$sess["pesan"] = $this->config->item('error_parameter');
			$keytoken = strtoupper(substr(sha1(uniqid()), 0, 16));;
			$sess['data'] = array(
				'token' =>  encrypt($keytoken, $this->config->item('keytoken')),
				'value' =>  encrypt(json_encode(array()), $keytoken)
			);
			echo json_encode($sess);
			exit();
		}
	}


	private function trx_shopeepay_kode()
	{
		$input = decrypt($this->input->post("trx_shopeepay_kode", true), $this->config->item('key'));
		$token = AUTHORIZATION::generateToken($input);
		try {
			$data = AUTHORIZATION::validateToken($token);
			if ($data === false) {
				$sess["status"] = "004";
				$sess["pesan"] = $this->config->item('error_parameter');
				$keytoken = strtoupper(substr(sha1(uniqid()), 0, 16));;
				$sess['data'] = array(
					'token' =>  encrypt($keytoken, $this->config->item('keytoken')),
					'value' =>  encrypt(json_encode(array()), $keytoken)
				);
				echo json_encode($sess);
				exit();
			} else {
				return $data;
			}
		} catch (Exception $e) {
			$sess["status"] = "004";
			$sess["pesan"] = $this->config->item('error_parameter');
			$keytoken = strtoupper(substr(sha1(uniqid()), 0, 16));;
			$sess['data'] = array(
				'token' =>  encrypt($keytoken, $this->config->item('keytoken')),
				'value' =>  encrypt(json_encode(array()), $keytoken)
			);
			echo json_encode($sess);
			exit();
		}
	}
}
